// illustrate inheritance.

// Create a superclass.
class A {
  int i = 22; // test inheritance of value
  int j = 33;

  void showij()
  {
    System.out.println("i and j: " + i + " " + j);
  }
}

// Create a subclass by extending class A.
class B extends A
{
  int k;

  void showk()
  {
    System.out.println("k: " + k);
  }
  void sum()
  {
    // how come the subclass can see i and j?
    System.out.println("i+j+k: " + (i+j+k));
  }
}

class Inheritance
{
  public static void main(String args[])
  {
    // call the constructor of the superclass
    A superOb = new A();
    // call the constructor of the subclass
    B subOb = new B();

    // The superclass has access to its members.
    superOb.i = 10;
    superOb.j = 20;
    System.out.println("Contents of superOb: ");
    superOb.showij();
    System.out.println();

    /* The subclass has access to all public
       members of its superclass. */

    //subOb.i = 7; CUT
    //subOb.j = 8; CUT

    // subclass also has access to its own members
    subOb.k = 9;
    System.out.println("Contents of subOb: ");
    // does the subclass have a showij() method?
    // if not, how does it have access to this method?
    subOb.showij();
    subOb.showk();
    System.out.println();

    System.out.println("Sum of i, j and k in subOb:");
    subOb.sum();


  }
}